/*
 * $Id: Field.cs,v 1.1.1.1 2009/09/20 13:25:16 kenta Exp $
 *
 * Copyright 2009 Kenta Cho. Some rights reserved.
 */
using System;
using SilverArcade.SilverSprite;
using Abagames.Util;

namespace Abagames.Hirarion
{
    /// <summary>
    /// Handling a game field and an offset of a scrolled screen.
    /// </summary>
    public class Field
    {
        public static Vector2 Size, SizeOuter;
        public static Vector2 ScreenOffset;

        public static void Initialize()
        {
            Size.X = 450;
            Size.Y = 350;
            SizeOuter = Size * 1.2f;
            ScreenOffset.X = Screen.Width / 2;
            ScreenOffset.Y = Screen.Height / 2;
        }

        public static void Draw()
        {
            int ox = (int)ScreenOffset.X % 16, oy = (int)ScreenOffset.Y % 16;
            int pi;
            for (int y = oy; y < Screen.Height; y += 16)
            {
                pi = y * Screen.Width + ox;
                for (int x = ox; x < Screen.Width; x += 16)
                {
                    Screen.Bitmap.Pixels[pi] = 0xff << 24 | 0x008800;
                    pi += 16;
                }
            }
        }

        public static bool Contains(Vector2 p)
        {
            return MathUtil.Contains(p, Size);
        }

        public static bool ContainsOuter(Vector2 p)
        {
            return MathUtil.Contains(p, SizeOuter);
        }
    }
}
