﻿/*
 * $Id: Frame.cs,v 1.1.1.1 2009/09/20 13:25:16 kenta Exp $
 *
 * Copyright 2009 Kenta Cho. Some rights reserved.
 */
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Abagames.Util
{
    /// <summary>
    /// Handling a frame rate.
    /// </summary>
    public class Frame
    {
        public delegate void UpdateMethod();
        public delegate void DrawMethod();
        private static UpdateMethod update;
        private static DrawMethod draw;

        public static void Initialize(UpdateMethod u, DrawMethod d)
        {
            update = u;
            draw = d;
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
        }

        private static void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            update();
            draw();
        }
    }
}
