﻿/*
 * $Id: Screen.cs,v 1.1.1.1 2009/09/20 13:25:16 kenta Exp $
 *
 * Copyright 2009 Kenta Cho. Some rights reserved.
 */
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Abagames.Util
{
    /// <summary>
    /// Handling a writeable bitmap.
    /// </summary>
    public class Screen
    {
        private const int background = 0xff << 24 | 0 << 16 | 0 << 8 | 0;
        public static WriteableBitmap Bitmap;
        public static int Width, Height;

        public static void Initialize(Canvas parent)
        {
            Width = (int)parent.Width;
            Height = (int)parent.Height;
            Bitmap = new WriteableBitmap(Width, Height);
            Image image = new Image();
            image.Source = Bitmap;
            parent.Children.Add(image);
        }

        public static void Clear()
        {
            int pl = Bitmap.Pixels.Length;
            for (int i = 0; i < pl; i++)
            {
                Bitmap.Pixels[i] = background;
            }
        }

        public static void Invalidate()
        {
            Bitmap.Invalidate();
        }
    }
}
